package sun.reflect;

import java.lang.reflect.Field;

class UnsafeQualifiedShortFieldAccessorImpl extends UnsafeQualifiedFieldAccessorImpl
{
    UnsafeQualifiedShortFieldAccessorImpl(Field field, boolean b) {
        super(field, b);
    }
    
    @Override
    public Object get(Object o) throws IllegalArgumentException {
        return new Short(this.getShort(o));
    }
    
    @Override
    public boolean getBoolean(Object o) throws IllegalArgumentException {
        throw this.newGetBooleanIllegalArgumentException();
    }
    
    @Override
    public byte getByte(Object o) throws IllegalArgumentException {
        throw this.newGetByteIllegalArgumentException();
    }
    
    @Override
    public char getChar(Object o) throws IllegalArgumentException {
        throw this.newGetCharIllegalArgumentException();
    }
    
    @Override
    public short getShort(Object o) throws IllegalArgumentException {
        this.ensureObj(o);
        return UnsafeQualifiedShortFieldAccessorImpl.unsafe.getShortVolatile(o, this.fieldOffset);
    }
    
    @Override
    public int getInt(Object o) throws IllegalArgumentException {
        return this.getShort(o);
    }
    
    @Override
    public long getLong(Object o) throws IllegalArgumentException {
        return (long)this.getShort(o);
    }
    
    @Override
    public float getFloat(Object o) throws IllegalArgumentException {
        return (float)this.getShort(o);
    }
    
    @Override
    public double getDouble(Object o) throws IllegalArgumentException {
        return (double)this.getShort(o);
    }
    
    @Override
    public void set(Object o, Object o2) throws IllegalArgumentException, IllegalAccessException {
        this.ensureObj(o);
        if (this.isReadOnly) {
            this.throwFinalFieldIllegalAccessException(o2);
        }
        if (o2 == null) {
            this.throwSetIllegalArgumentException(o2);
        }
        if ((o2 instanceof Byte)) {
            UnsafeQualifiedShortFieldAccessorImpl.unsafe.putShortVolatile(o, this.fieldOffset, (short)(byte)o2);
            return;
        }
        if ((o2 instanceof Short)) {
            UnsafeQualifiedShortFieldAccessorImpl.unsafe.putShortVolatile(o, this.fieldOffset, (short)o2);
            return;
        }
        this.throwSetIllegalArgumentException(o2);
        return;
    }
    
    @Override
    public void setBoolean(Object o, boolean b) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(b);
    }
    
    @Override
    public void setByte(Object o, byte b) throws IllegalArgumentException, IllegalAccessException {
        this.setShort(o, (short)b);
    }
    
    @Override
    public void setChar(Object o, char c) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(c);
    }
    
    @Override
    public void setShort(Object o, short x) throws IllegalArgumentException, IllegalAccessException {
        this.ensureObj(o);
        if (this.isReadOnly) {
            this.throwFinalFieldIllegalAccessException(x);
        }
        UnsafeQualifiedShortFieldAccessorImpl.unsafe.putShortVolatile(o, this.fieldOffset, x);
    }
    
    @Override
    public void setInt(Object o, int n) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(n);
    }
    
    @Override
    public void setLong(Object o, long n) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(n);
    }
    
    @Override
    public void setFloat(Object o, float n) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(n);
    }
    
    @Override
    public void setDouble(Object o, double n) throws IllegalArgumentException, IllegalAccessException {
        this.throwSetIllegalArgumentException(n);
    }
}
